/************************************************/
/*  Uzduotis nr. n16                            */
/*  Sudaryti vienpusi sarasa. Parasyti          */
/* paprograme, kuri kopijuoja eiles numeriu     */
/* nurodyta elementa ir iterpia kopijuojama     */
/* elementa saraso pradzioje. Jei tiek elementu */
/* sarase nera, tai turi buti isvedamas         */
/* pranesimas.                                  */
/*  Atliko: Raminta SUTKUTE, 1 kursas, MIM      */
/*                                              */
/************************************************/



#include <stdio.h>
#include <stdlib.h>

struct el
                { 
                  int duom;
                  struct el *kitas;
                };  


void Sukurti_sar (struct el **, struct el **);
void Spausdinti_sar (struct el *);
void Kopijuoti_el ( struct el **, int);
    
int main()
     {
         struct el *pradzia, *pabaiga;
         int k;
         Sukurti_sar (&pradzia, &pabaiga);
         Spausdinti_sar (pradzia);
         printf ("Iveskite elemento eiles numeri, kuri norite iterpti i saraso pradzia:");
         scanf ("%d", &k); 
         Kopijuoti_el (&pradzia,k);
         Spausdinti_sar (pradzia);
         system("pause");
         
     }
     

/* Iterpti elementa i saraso pradzia */

void Sukurti_sar (struct el * *pr, struct el * *pab)
{
     struct el *g;
     int reiksme;
     
     puts ("Iveskite saraso elementus. Noredami baigti, iveskite 0:");
     *pr  = NULL;
     *pab = NULL;
     scanf("%d", &reiksme);
     
     while(reiksme !=0)
     {
                   if ( *pr == NULL)
                      {
                            g = (struct el *) malloc(sizeof(struct el));
                            g->duom = reiksme;
                            g->kitas = NULL;
                            *pab = g;
                            *pr = g;
                      }
                   else
                       {
                            g =(struct el *)malloc(sizeof(struct el));
                            g->duom = reiksme;
                            g->kitas =NULL;
                            (*pab)->kitas = g;
                            *pab = g;
                       }
                   scanf ("%d", &reiksme);
                  
     }
      puts ("Sarasas sekmingai sukurtas");
      
}
/* Spausdinti nuo pradzios */
void Spausdinti_sar (struct el *elem)
     {
         int i=1;
         puts ("******************************************");
         puts ("Spausdiname sarasa:");
         while (elem != NULL)
               {
                     printf("%d elementas yra %d\n", i, elem->duom);
                     elem = elem->kitas;
                     i++;
               }
              
     }
/* Kopijuoti_el */
void Kopijuoti_el ( struct el* *pr, int k)
    {
                  struct el *elem, *elemk, *elems;
                  int i;
                  elemk = *pr;
                  i=2;
                  while (i < k && elemk !=NULL)
                        {
                           elemk = elemk->kitas;
                           i++;
                        }   

                  if ( i==k )
                  {
                     elem = elemk->kitas;
                     k = elem->duom;
                     elems = (struct el *) malloc (sizeof (struct el));
                     elems->duom = k;
                     elems->kitas = *pr;
                     *pr= elems;
                  } 
                  else printf("Sarase yra maziau nei %d elementu.",k);
                  
    
    }
